-- The Ada 95 Booch Components (Version 1.0 beta 1)
-- Copyright (C)1994-1997 Grady Booch and David Weller.  All Rights Reserved.
-- 
--      This program is free software; you can redistribute it
--      and/or modify it under the terms of the Ada Community
--      License which comes with this Library.
--
--      This program is distributed in the hope that it will be
--      useful, but WITHOUT ANY WARRANTY; without even the implied
--      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
--      PURPOSE. See the Ada Community License for more details.
--      You should have received a copy of the Ada Community
--      License with this library, in the file named "Ada Community
--      License" or "ACL". If not, contact the author of this library 
--      for a copy.
--
-- This file is the implementation of the User-defined testing type

with Text_Io; use Text_Io;
package body User_Defined is

   function Priority(Obj : in Chunk) return Integer is
   begin
     return Obj.Number;
   end Priority;

   function "<"(L,R: Chunk) return Boolean is
   begin
     return Priority(L) < Priority(R);
   end "<";

   procedure Message(Obj : Chunk) is
   begin
      Put_Line("[ID: " & Integer'Image(Obj.Number) & "." & 
	       Integer'Image(Obj.Count) &"]");
   end Message;

   procedure Initialize(Obj : in out Chunk) is
   begin
      Obj.Magic := Obj.Magic + 1;
   end Initialize;

   procedure Adjust(Obj : in out Chunk) is
   begin
      Obj.Count := Obj.Count + 1;
   end Adjust;

   procedure Finalize(Obj : in out Chunk) is
   begin
      null;
   end Finalize;


end User_Defined;
