-- The Ada 95 Booch Components (Version 1.0 beta 1)
-- Copyright (C)1994-1997 Grady Booch and David Weller.  All Rights Reserved.
-- 
--      This program is free software; you can redistribute it
--      and/or modify it under the terms of the Ada Community
--      License which comes with this Library.
--
--      This program is distributed in the hope that it will be
--      useful, but WITHOUT ANY WARRANTY; without even the implied
--      warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
--      PURPOSE. See the Ada Community License for more details.
--      You should have received a copy of the Ada Community
--      License with this library, in the file named "Ada Community
--      License" or "ACL". If not, contact the author of this library 
--      for a copy.
--
-- Class used for testing user-defined data structures

with Ada.Finalization;
package User_Defined is
   type Chunk is private;

   type Chunk_Ptr is access all Chunk;

   function Priority(Obj : in Chunk) return Integer;

   function "<"(L,R: Chunk) return Boolean;

   procedure Message(Obj : Chunk);

private
   use Ada.Finalization;

   type Chunk is new Controlled with record
      Number : Integer := 0;
      Count  : Integer := 0;
      Magic  : Integer := 0;
   end record;

   procedure Initialize(Obj : in out Chunk);
   procedure Adjust(Obj : in out Chunk);
   procedure Finalize(Obj : in out Chunk);

end User_Defined;
